
# This is a function to skip the rest of the file when it finds a match
function nextfile()   { _abandon_ = FILENAME; next }
_abandon_ == FILENAME {
      if (FNR == 1)
          _abandon_ = ""
      else
          next
   }

# Here is the start.

{
# if we are working with the first file, which is the output of getmac.exe
if (fileno == 1) {

   mac = ""
# Convert the input to lowercase
   $0 = tolower($0)

# First we have to extract the MAC from the output of getmac.exe. It is in the form of (#[0xHH 0xHH 0xHH 0xHH 0xHH 0xHH ])
# in later versions, you can use a easier pattern for mac address. For example,
# 0x(([[::xdigit::]] ){2)){5}[[::xdigit::]]{2}  But there were limitations in older versions so I settled
# for this long match. It is matching lower case hex digits but input is converted to lowercase in previous command

   pos = match($0,/0x[a-f0-9][a-f0-9] 0x[a-f0-9][a-f0-9] 0x[a-f0-9][a-f0-9] 0x[a-f0-9][a-f0-9] 0x[a-f0-9][a-f0-9] 0x[a-f0-9][a-f0-9]/)
   mac = substr($0,RSTART,RLENGTH)

# Now, we have to strip unwanted characters and forms the MAC address with familiar format.
   gsub("0x","",mac)
   gsub(" ","-",mac)

# Print the MAC to file for debuging purposes if you need
   print mac  > "macaddr.txt"

# Since we found a MAC address, go to next file. This is not really necessary since there is only one line in the getmac output
   fileno = 2
   nextfile()
   }

# Now the next file, which has MAC addresses and Computer Names. Look for the line with the above MAC, remove all white
# spaces if you find a line, and then remove the MAC address. This will leave only the Computer Name given for that
# MAC address.

if (fileno == 2) {
# check if it has a MAC address. In case if it did not find a MAC address at all, for example if no packet driver installed, use
# a static name. I wanted to use a ranodm name here, but rand() seems to start with same value, and srand is not implemented in
# older versions.

     if (mac == "") {
       CompName = "NoMac"
       nextfile()
     }
     $0 = tolower($0)
     if (match($0,mac) != 0) {
        CompName = $0
        gsub(" ","",CompName)
        gsub("\t","",CompName)
        gsub(mac,"",CompName)
        nextfile()
     }
   }
}

# Use the END block to check if it had found a mach. Remember, AWK run this script for each line.
# Since we checked for not having a MAC address before, it can fail to find a match if the names.txt
# file does not contain the MAC address of this machine. In that case, use a static string
# I wanted to use a Random number here, but it was not possible since the rand()
# function always start with the same value. It uses a Random name in VBScript version

END {
  if ( CompName == "") {
     CompName = "NotFound"
  }
# Now create the ghregupd.reg file to use with GHConfig. This is the default file name for ghconfig.
# It is in the form of
#       CONFIG_COMMANDS COMPUTERNAME = "MACH-1" "MACH-1" DNSHOST = "MACH-1" "MACH-1" END_CONFIG_COMMANDS
# for the name MACH-1
# You can find more about the format in GSS manual.

  print "CONFIG_COMMANDS COMPUTERNAME = " "\"" CompName "\" \"" CompName "\" DNSHOST = " "\"" CompName "\" \"" CompName "\"" " END_CONFIG_COMMANDS"> "ghregupd.reg"
}