'*************************************************
'Cahnage machine names based on Mac Address without Ghost client being installed
'
'Based on a text file, this sets the machines name of the computer. This could be
'executed after cloning
'
' Krish - 10th May 2008
'*************************************************


Option Explicit

Dim strComputerName
Dim FSO, strMacToNameFileName
Dim colMacToName
Dim strConfigFileName, objConfigFile
Dim intRet

strMacToNameFileName = "Mac2Name.txt"
strConfigFileName = "GHREGUPD.REG"

Set FSO = CreateObject("Scripting.FileSystemObject")

'Main routine

'Call function to get the computer name
intRet = fintGetMactoNameData(strMacToNameFileName, colMacToName)

'If we get a computer name successfully, use it. Else set the computer name to a ranodm number with prefix Err-
If IntRet = 0 Then
   strComputerName = fstrGetComputerName(colMactoName)
Else
   strComputerName = "Err-" & int(Rnd(1200)* 12345)
End IF

'Create the ghregupd.reg file to use with ghconfig32.
Set objConfigFile = FSO.CreateTextFile(strConfigFileName)
    objConfigFile.WriteLine "CONFIG_COMMANDS COMPUTERNAME = """ & strComputerName & """  """ & strComputerName & """" & _
                            " DNSHOST = """ & strComputerName & """ """ & strComputerName & """ END_CONFIG_COMMANDS"
objConfigFile.Close

'*******************End Main ******************************


'*************************************************
'Retrun the ComputerName, when called with a dictionary
'Objrct containing Mac & Computername
'*************************************************
Function fstrGetComputerName(ByRef lcolMacToName)
   Dim objWShell, lstrMacAddress, lobjWMI, lcolNetConfigs, lobjConfig

   set objWShell = CreateObject("WScript.Shell")

   'Look for MAC addresses. Save the first one anyway. if there are any other addresses, replace the saved 
   'address only if the new address is  not a VMWare address. In this way, we can get the get the physical
   'MAC address. We can't omnit VMWare virtual address range all togeter since VMWare clients use
   'the same range when setup with static MAC. This can handle both VMWare hosts and guests.


   lstrMacAddress = ""

   Set lobjWMI = GetObject("WinMgmts:\\.\root\cimv2")
   Set lcolNetConfigs = lobjWMI.ExecQuery("Select MACAddress from WIn32_NetWorkAdapterConfiguration Where IPENABLED = True")
   For each lobjConfig in lcolNetConfigs
        If lstrMacAddress = "" Then
           lstrMacAddress = lobjConfig.MacAddress
        Else
          if (Left(lstrMacAddress, 8) = "00:50:56") Then lstrMacAddress = lobjConfig.Macaddress 'WMI uses : instead of - in MAC Addresses
        End IF
   Next

   lstrMACAddress = Replace(lstrMACAddress,":","-")

   'Look for the corrosponding name in the text file and assign the computer name. In case if we don't find the MAC address in the 
   'text file, use the last 8 characters of MAC address with prefix MAC-. In this way, we can identify the client easily. If we did not 
   'get a MAC address at all, assign a random number with prefix NOTFOUND-
   If lstrMacAddress <> "" Then
      If lcolMacToName.Exists(lstrMacAddress) Then
         fstrGetComputerName = lcolMacToName.item(lstrMacAddress)
      Else
         fstrGetComputerName = "MAC-" & right(lstrMacAddress,8)
      End IF
   Else
      Randomize
      fstrGetComputerName = "NOTFOUND-" & int(Rnd(1000)*12345)
   End IF
End Function
'***************End Function fstrGetComputerName**********************************



'*************************************************
'Retruns lcolMacToName with the data from file
'File should have the format MACADDRESS = Computername
' 11-11-11-11-11-11  = MYComputerName

'*************************************************

Function fintGetMacToNameData(ByVal lstrMacToNameFileName, ByRef lcolMacToName)
    Dim lobjFSO
    Dim lregFindMac, lobjMacToNameFile
    Dim lstrTemp, lstrTmpMac, lcolMatches, lcolMatch, lstrTmpComputerName


    Set lobjFSO = CreateObject("Scripting.FileSystemObject")

    'add the MAC/Name pairs to a dictionary object. It is much easier than having a loop to go through it when looking for
    'Computer name

    If FSO.FileExists(lstrMacToNameFileName) Then
       Set lcolMacToName = CreateObject("Scripting.Dictionary")
       Set lregFindMac = New RegExp
       'set the pattern to look for two hex chars, then a dash, full string repeated five times and again two hex chars,
       'any number of whitespaces
       'Then a stirng consisting of digits, letters and hyphen
       lregFindMac.pattern = "((((\d|[A-F]){2}-){5}(\d|[A-F]){2})\s*((\w|-)*))"
       lregFindMac.ignoreCase = True

       Set lobjMacToNameFile = FSO.OpenTextFile(lstrMacToNameFileName, 1, False)
       While Not lobjMacToNameFile.AtEndOfStream
          lstrTemp = lObjMacToNameFile.ReadLine
          Set lcolMatches = lregFindMac.Execute(lstrTemp)
          If lcolMatches.Count > 0 then
             set lcolMatch = lcolMatches(0)
             lstrTmpMac = lcolMatch.SubMatches(1)
             lstrTmpComputerName = lcolMatch.SubMatches(5)
	     'Check if it is a duplicate entry
             if Not lcolMacToName.Exists(lstrTmpMac) Then
                lcolMacToName.Add lstrTmpMac, lstrTmpComputerName
             End If
          End IF
       Wend
       fintGetMacToNameData = 0
       lobjMacToNameFile.CLose
    Else
       fintGetMacToNameData = 1
    End IF
End Function

'****************End fintGetMacToName*********************************

